//+-------------------------------------------------------------------------------+ 
//|                                                       TenkanSen_Kumo Nrtr.mq4 |
//|                                                   original template by mladen |
//|                                                           this mod by mrtools |
//+-------------------------------------------------------------------------------+
#property copyright "http://www.forex-tsd.com/"
#property link      "http://www.forex-tsd.com/"
#include <stdlib.mqh>
#include <stderror.mqh>
#define  PAUSE_BEFORE_RETRY 500

//
//
//
//
//

extern bool   EcnBroker                   = true;
extern bool   NoHedge                     = false;
extern bool   UseAutoMagic                = true;
extern int    ManualMagic                 = 19283745;
extern bool   UseAutomaticMM              = false;
extern bool   AllowMultipleTradesOnBar    = false;
extern bool   AllowOnlyOneActiveTrade     = true;
extern double Risk                        = 1.50;
extern double BaseLot                     = 0.1;
extern bool   CloseOnTrendChange          = false;

extern string  ____Positions              = "Positions settings";
extern double  TakeProfitPips             = 10;
extern double  StopLossPips               = 50;
extern double  CloseWhenProfit            = 0;
extern double  CloseWhenLoss              = 0;
extern bool    AllSymbolsForProfitAndLoss = false;
extern bool    StopWhenClosedAllTrades    = false;
extern bool    SpreadProtection           = true; // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int     PipTolerance               = 2;    // value in pips over normal spread to activate the SpreadProtection.

extern string  _                          = "Ichimoku Filter";
extern int     ichTf                      = 0;
extern int     Tenkan                     = 9;
extern int     Kijun                      = 26;
extern int     Senkou                     = 52;
extern int     ichibar                    = 1; 

extern string  _________                  = "Nrtr Filter";
extern bool    UseNrtr                    = false;
extern int     ATR                        = 14;
extern double  Coefficient                = 4;
extern int     nrtrbar                    = 1;

extern string  ____                       = "Rsi Filter";
extern bool    UseRsi                     = false;
extern int     PeriodRSI                  = 7;
extern int     RsiPrice                   = 0;
extern double  levelOb                    = 70;
extern double  levelOs                    = 30;
extern int     rsibar                     = 1;

extern string  __                         = "Psar Filter";
extern bool    UsePsar                    = true;
extern double  AccStep                    = 0.02;
extern double  AccLimit                   = 0.2;
extern int     PriceHigh                  = PRICE_HIGH;
extern int     PriceLow                   = PRICE_LOW;
extern int     sarbar                     = 1;

extern string  ____voltyTrailingStop      = "Volty trailing stop settings (if used)";
extern bool    UseVoltyTrailingStop       = false;
extern int     vol.timeFrame              = 5;
extern int     Price                      = 0;
extern double  Length                     = 2;
extern double  Phase                      = 0;
extern bool    Double                     = true;
extern int     AtrLength                  = 10; 
extern double  Kv                         = 4;  
extern double  MoneyRisk                  = 1; 
extern int     vol.barToUse               = 1;    
extern int     Volty.initialStopLoss      = 50;

extern string  ____TimeFilter             = "Time filter settings";
extern string  Trade.startFrom            = "05:00";
extern string  Trade.endAt                = "13:00";

extern string  ____Other                  = "";
extern int     AllowedSlippage            =  0;
extern bool    showMessages               = false;

//
//
//
//
//

int     NumberOfTries = 5;
int     digit = 0;
int     MagicNumber;
int     DontContinue;
double  Spread,WorstSpread,NormalSpread;
double  pipMultiplier = 1;

//
//
//
//
//

string  s_symbol;
string  IEAMessagesID;
int     IEAMessagesIDLength;
#define IEAMessagesIDMagic EMPTY_VALUE
#define IEAMessagesIDExSep "-ex:"

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   s_symbol = Symbol();
   if (UseAutoMagic) MagicNumber = GetMagic();
               else  MagicNumber = ManualMagic;  
                  
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
   
   NormalSpread = MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,Digits%2);
            
   if (AllSymbolsForProfitAndLoss)
            IEAMessagesID = "IchiNrtr"+MagicNumber;
   else     IEAMessagesID = "IchiNrtr"+MagicNumber+s_symbol;
   IEAMessagesIDLength = StringLen(IEAMessagesID);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define __trendUp       1
#define __trendDown    -1
#define __trendNeutral  0

//
//
//
//
//

int start()
{     
   if (!CheckTerminalStatus()) return(0);       

   //
   //
   //
   //
   //

      if (StopLossPips<=0)
           bool forceCloseOnTrendChange = True;
      else      forceCloseOnTrendChange = CloseOnTrendChange; 
           bool stopedTrading           = false;
           int  trendDirection          = findTrend();

                        manageOpenedOrders(trendDirection,forceCloseOnTrendChange,stopedTrading);

      if (stopedTrading) return(0);

   //
   //
   //
   //
   //

         double totalProfit  = 0;
         int    openedBuys   = 0;
         int    openedSells  = 0;
         int    openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         
         //
         //
         //
         //
         //

         if (CloseWhenProfit>0 &&  totalProfit >= CloseWhenProfit)
         {
            if (StopWhenClosedAllTrades) PostMessage();
                  CloseAll(); openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         }
         if (CloseWhenLoss > 0 && totalProfit <= -CloseWhenLoss)
         {
            if (StopWhenClosedAllTrades) PostMessage();
                  CloseAll(); openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         }
         if (FindMessage()) return(0);
      
         //
         //
         //
         //
         //
      
         bool canEnterNewTrade = true;

            if (AllowOnlyOneActiveTrade) canEnterNewTrade = (openedOrders==0);
            else                         canEnterNewTrade = (countOpenedOnACurrentBar()==0);

   //
   //
   //    time fiter checking
   //
   //
      
         if (canEnterNewTrade)
         {
            string     st1 = normalizeTime(Trade.startFrom);
            string     et1 = normalizeTime(Trade.endAt);
            datetime   ts1  = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+st1); datetime ts2 = ts1;
            datetime   te1  = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+et1); datetime te2 = te1;
            if (te1<ts1) { ts1 -= 24*60*60; te2 += 24*60*60; }
                    canEnterNewTrade = ((TimeCurrent()>=ts1 && TimeCurrent()<=te1) || (TimeCurrent()>=ts2 && TimeCurrent()<=te2));
         }

   //
   //
   //
   //
   //
   
   if (canEnterNewTrade && trendDirection != __trendNeutral)
   {
      if (countClosedOrders()>0) return(0);
      
      //
      //
      //
      //
      //

      if (!UseVoltyTrailingStop)
            double tradeLots = getLots(StopLossPips);
      else         tradeLots = getLots(Volty.initialStopLoss);
      if(AccountFreeMargin()<tradeLots*MarketInfo(s_symbol,MODE_MARGINREQUIRED))
         { showTwoStateMessage("money","Not enough money to trade "+DoubleToStr(tradeLots,2),false); return(0); }
      else showTwoStateMessage("money","Continuing to trade",true);
      
      //
      //
      //
      //
      //
      
      Spread = MarketInfo(Symbol(),MODE_SPREAD)/pipMultiplier;
      if (Spread>WorstSpread) WorstSpread=Spread;
      if (SpreadProtection && Spread>NormalSpread+PipTolerance) DontContinue=1; else DontContinue=0;
      
      //
      //
      //
      //
      //
      
      if (trendDirection==__trendUp   && openedSells==0 && DontContinue==0) Buy(tradeLots);
      if (trendDirection==__trendDown && openedBuys ==0 && DontContinue==0) Sell(tradeLots);
   }  
   return(0);      
}

//----------------------------------------------------------------------------------------
//                                 
//----------------------------------------------------------------------------------------
//
//
//
//    lots and range calculation
//
//
//

double getLots(double range)
{
   RefreshRates();
   double step   = MarketInfo(s_symbol,MODE_LOTSTEP);
   double minLot = MarketInfo(s_symbol,MODE_MINLOT);
   double maxLot = MarketInfo(s_symbol,MODE_MAXLOT);
   double lots   = BaseLot;
   if (UseAutomaticMM)
   {
      if (Risk>0)
      {
         lots = AccountFreeMargin()*(Risk/100.0)/(range*MarketInfo(s_symbol,MODE_TICKVALUE)/Point);
      }
   }      
return(MathMax(MathMin(lots,maxLot),minLot));   
}


//----------------------------------------------------------------------------------------
//       trend determination       
//----------------------------------------------------------------------------------------
//
//
//
//
//

int findTrend()
{
   RefreshRates();
   
   //
   //
   //
   //
   //
   
   double ichi1    = iCustom(s_symbol,ichTf,"Kumo_Breakout_Histo",Tenkan,Kijun,Senkou,0,ichibar);
   double ichi2    = iCustom(s_symbol,ichTf,"Kumo_Breakout_Histo",Tenkan,Kijun,Senkou,1,ichibar);
   double nrtrNow  = iCustom(s_symbol,0,"NRTR_ATR_STOP",ATR,Coefficient,3,nrtrbar);
   double nrtrPre  = iCustom(s_symbol,0,"NRTR_ATR_STOP",ATR,Coefficient,3,nrtrbar+1);
   double rsinow   = iCustom(s_symbol,0,"rsi",PeriodRSI,RsiPrice,0,rsibar);
   double rsipre   = iCustom(s_symbol,0,"rsi",PeriodRSI,RsiPrice,0,rsibar+1);
   double rsipre2  = iCustom(s_symbol,0,"rsi",PeriodRSI,RsiPrice,0,rsibar+2);
   double sarupnow = iCustom(s_symbol,0,"Parabolic SAR 2",AccStep,AccLimit,PriceHigh,PriceLow,true,0,sarbar);
   double saruppre = iCustom(s_symbol,0,"Parabolic SAR 2",AccStep,AccLimit,PriceHigh,PriceLow,true,0,sarbar+1);
   double sardnnow = iCustom(s_symbol,0,"Parabolic SAR 2",AccStep,AccLimit,PriceHigh,PriceLow,true,1,sarbar);
   double sardnpre = iCustom(s_symbol,0,"Parabolic SAR 2",AccStep,AccLimit,PriceHigh,PriceLow,true,1,sarbar+1);
   
   //
   //
   //
   //
   //
   
   if (UseNrtr)
   {
     bool posNrtr = (nrtrNow>0 && nrtrPre<0);
     bool negNrtr = (nrtrNow<0 && nrtrPre>0);
   }
   else      
   {
         posNrtr = true;
         negNrtr = true;
   }
   
   
   if (UseRsi)
   {
     bool rsislopingUp = (rsinow < levelOb && rsinow > levelOs && rsinow > rsipre);
     bool rsislopingDn = (rsinow < levelOb && rsinow > levelOs && rsinow < rsipre);
   }
   else      
   {
         rsislopingUp = true;
         rsislopingDn = true;
   }
   
   if (UsePsar)
   {
     bool bullsar = (sarupnow != EMPTY_VALUE && sardnpre != EMPTY_VALUE && saruppre == EMPTY_VALUE && sardnnow == EMPTY_VALUE);
     bool bearsar = (sardnnow != EMPTY_VALUE && saruppre != EMPTY_VALUE && sardnpre == EMPTY_VALUE && sarupnow == EMPTY_VALUE);
   }
   else      
   {
         bullsar = true;
         bearsar = true;
   }
   
   //
   //
   //
   //
   //

   if (ichi1==1 && ichi2==EMPTY_VALUE && rsislopingUp && bullsar) return(__trendUp);
   if (ichi2==1 && ichi1==EMPTY_VALUE && rsislopingDn && bearsar) return(__trendDown);
                                                                  return(__trendNeutral);
}

//----------------------------------------------------------------------------------------
//       orders counters
//----------------------------------------------------------------------------------------
//
//
//
//
//

int countOpenedOrders(int& openedBuys,int& openedSells,double& totalProfit)
{
   int openedOrders = 0;   
       openedBuys   = 0;
       openedSells  = 0;
       totalProfit  = 0;
   
   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
   
      //
      //
      //
      //
      //
      
      if(AllSymbolsForProfitAndLoss)
      {
         if(OrderMagicNumber() == MagicNumber)
         if(OrderType() == OP_BUY || OrderType() == OP_SELL) totalProfit  += (OrderProfit()+OrderSwap()); 
      }
      if(OrderSymbol() != s_symbol) continue;
      if(NoHedge)
      {
         if(OrderType() == OP_BUY)  openedBuys++; 
         if(OrderType() == OP_SELL) openedSells++;
      }
      if(OrderMagicNumber() != MagicNumber) continue;
                  
      //
      //
      //
      //
      //
                  
      if(OrderType() == OP_BUY || OrderType() == OP_SELL) { openedOrders++; if (!AllSymbolsForProfitAndLoss) totalProfit  += (OrderProfit()+OrderSwap()); }
   }      
   return(openedOrders);
}

//
//
//
//
//

int countClosedOrders()
{
   int      closedAtBar = 0;    
   datetime startTime   = Time[0];
   datetime endTime     = Time[0]+Period()*60;
   
   for(int i = OrdersHistoryTotal()-1; i >= 0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == false) break;
      if(OrderMagicNumber() != MagicNumber)                       continue;
      if(OrderSymbol()      != s_symbol)                          continue;
      if(OrderCloseTime()<startTime || OrderCloseTime()>=endTime) continue; 
         closedAtBar++;
         break;
   } 
   return(closedAtBar); 
}  

//
//
//
//
//

int countOpenedOnACurrentBar()
{
   int      openedAtBar = 0;    
   datetime startTime   = Time[0];
   datetime endTime     = Time[0]+Period()*60;
   
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderMagicNumber() != MagicNumber)                     continue;
      if(OrderSymbol()      != s_symbol)                        continue;
      if(OrderOpenTime()<startTime || OrderOpenTime()>=endTime) continue; 
         openedAtBar++;
         break;
   } 
   return(openedAtBar); 
}  



//----------------------------------------------------------------------------------------
//       opened orders management 
//----------------------------------------------------------------------------------------
//
//
//
//
//

void manageOpenedOrders(int currentDirection,bool doCloseOnTrendChange, bool stoped)
{
   double TakeProfit = TakeProfitPips*Point*pipMultiplier;
   double StopLoss   = StopLossPips  *Point*pipMultiplier;
   double newStop;
   double curStop;
   double maxStop;
   
   //
   //
   //
   //
   //
   
   for(int i=OrdersTotal()-1; i >= 0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      
      //
      //
      //    check if stop when profit was signaled
      //    do not trade untill the sell stop order expires or is deleted
      //
      //

      if(OrderMagicNumber() == IEAMessagesIDMagic && OrderType()==OP_BUYLIMIT && StopWhenClosedAllTrades)
      {
         if (StringSubstr(OrderComment(),0,IEAMessagesIDLength)==IEAMessagesID)
         {
            int pos = StringFind(OrderComment(),IEAMessagesIDExSep);
            if (pos>-1)
            {
               datetime expiring = StrToDouble(StringSubstr(OrderComment(),pos+4,0));
                     if(expiring <= TimeCurrent())
                     {
                        OrderDelete(OrderTicket());
                        return;
                     }                        
            }
            CloseAll(); stoped=true; return;
         }            
      }

      //
      //
      //
      //
      //
      
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol()      != s_symbol)    continue;

      //
      //
      //
      //
      //

      int err = 0;      
      if(OrderType() == OP_BUY)
      {
         if (doCloseOnTrendChange) { if (currentDirection==__trendDown) { CloseOrder(0,OrderTicket()); continue; }}
         if (EcnBroker && StopLoss>0)   { if (OrderStopLoss()==0)   { RefreshRates(); setStopLoss(OrderTicket()  ,OrderOpenPrice()-StopLoss);}}
         if (EcnBroker && TakeProfit>0) { if (OrderTakeProfit()==0) { RefreshRates(); setTakeProfit(OrderTicket(),OrderOpenPrice()+TakeProfit);}}
         
         //
         //
         //
         //
         //
         
         for(int c=0; c < NumberOfTries; c++)
         { 
            RefreshRates();
               if (!UseVoltyTrailingStop)
                     double trailingStopBuy = Bid-StopLossPips*pipMultiplier;
               else         trailingStopBuy = volbuyValue(s_symbol);
            
               //
               //
               //
               //
               //
               
               curStop = NormalizeDouble(OrderStopLoss(),digit);
               newStop = NormalizeDouble(trailingStopBuy,digit);
               maxStop = NormalizeDouble(Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point,digit);
               if (newStop > curStop && newStop < maxStop)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                  err = GetLastError(); checkError("stop loss modified",err);
               }
        			switch (err)
 	       	   {
        			   case ERR_SERVER_BUSY:
		            case ERR_NO_CONNECTION:
		            case ERR_INVALID_PRICE:
		            case ERR_OFF_QUOTES:
		            case ERR_BROKER_BUSY:
		            case ERR_TRADE_CONTEXT_BUSY:
			                 Sleep(PAUSE_BEFORE_RETRY);
			                 continue;

		            case ERR_PRICE_CHANGED:
		            case ERR_REQUOTE:
				              continue;

		            default:
			                 c=NumberOfTries;
			                 continue;
               }
         }
      }
      
      //
      //
      //
      //
      //
      
      if(OrderType() == OP_SELL)
      {
         if (doCloseOnTrendChange) { if (currentDirection==__trendUp) { CloseOrder(0,OrderTicket()); continue; }}
         if (EcnBroker && StopLoss>0)   { if (OrderStopLoss()==0)   { RefreshRates(); setStopLoss(OrderTicket()  ,OrderOpenPrice()+StopLoss);}}
         if (EcnBroker && TakeProfit>0) { if (OrderTakeProfit()==0) { RefreshRates(); setTakeProfit(OrderTicket(),OrderOpenPrice()-TakeProfit);}}

         //
         //
         //
         //
         //
         
         for(c=0; c < NumberOfTries; c++)
         { 
            RefreshRates();
               if (!UseVoltyTrailingStop)
                     double trailingStopSell = Bid+StopLossPips*pipMultiplier;
               else         trailingStopSell = volsellValue(s_symbol);
               
               //
               //
               //
               //
               //
               
               curStop = NormalizeDouble(OrderStopLoss(),digit);
               newStop = NormalizeDouble(trailingStopSell,digit);
               maxStop = NormalizeDouble(Ask+MarketInfo(s_symbol,MODE_STOPLEVEL)*Point,digit);
               if (curStop > 0 && newStop < curStop && newStop > maxStop)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                  err = GetLastError(); checkError("stop loss modified",err);
               }                        
        			switch (err)
  	       	   {
        			   case ERR_SERVER_BUSY:
		            case ERR_NO_CONNECTION:
		            case ERR_INVALID_PRICE:
		            case ERR_OFF_QUOTES:
		            case ERR_BROKER_BUSY:
		            case ERR_TRADE_CONTEXT_BUSY:
   		                 Sleep(PAUSE_BEFORE_RETRY);
	  	                    continue;

		            case ERR_PRICE_CHANGED:
		            case ERR_REQUOTE:
   			              continue;

		            default:
			                 c=NumberOfTries;
			                 continue;
               }
         }                  
      }
   }
}

//----------------------------------------------------------------------------------------
//       orders management
//----------------------------------------------------------------------------------------
//       buy and sell orders
//----------------------------------------------------------------------------------------
//
//
//
//
//

void setStopLoss(int ticket,double stopLoss)
{
   if (ticket != -1)
   for(int c=0; c < NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),stopLoss,OrderTakeProfit(),0);
         int     err = GetLastError(); checkError("stop loss applied",err);
         switch (err)
	  	   {
            case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
			        Sleep(PAUSE_BEFORE_RETRY);
			        continue;

            case ERR_PRICE_CHANGED:
			   case ERR_REQUOTE:
				     continue;

            default:
	              c = NumberOfTries;
	              continue;
         }
   }
}

//
//
//
//
//

void setTakeProfit(int ticket,double takeProfit)
{
   if (ticket != -1)
   for(int c=0; c < NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),takeProfit,0);
         int     err = GetLastError(); checkError("take profit applied",err);
         switch (err)
	  	   {
            case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
			        Sleep(PAUSE_BEFORE_RETRY);
			        continue;

            case ERR_PRICE_CHANGED:
			   case ERR_REQUOTE:
				     continue;

            default:
	              c=NumberOfTries;
	              continue;
         }
   }
}

//
//
//
//
//

void Buy(double Lots)
{ 
   double TakeProfit = TakeProfitPips*Point*pipMultiplier;
   double StopLoss   = StopLossPips  *Point*pipMultiplier;
   if (UseVoltyTrailingStop)
          StopLoss   = Volty.initialStopLoss*Point*pipMultiplier;
   
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0; c < NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss > 0)   sl = Ask-StopLoss;
            if (TakeProfit > 0) tp = Ask+TakeProfit;
         }            
         int ticket = OrderSend(s_symbol,OP_BUY,Lots,Ask,AllowedSlippage*Point*pipMultiplier,sl,tp,"IchiNrtr-buy",MagicNumber,0,Blue);
         
         //
         //
         //
         //
         //
         
         int     err = GetLastError(); checkError("buy order opened",err);
  			switch (err)
         {
            case ERR_NO_ERROR:
                 if (EcnBroker && StopLoss>0)   setStopLoss(ticket,Ask-StopLoss);
                 if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Ask+TakeProfit);
                     c=NumberOfTries;
                 continue;
			                 
			   case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
                 Sleep(PAUSE_BEFORE_RETRY);
                 continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
	              continue;

            default:
                 c=NumberOfTries;
                 continue;
         }
   } 	    
}

//
//
//
//
//

void Sell(double Lots)
{        
   double TakeProfit = TakeProfitPips*Point*pipMultiplier;
   double StopLoss   = StopLossPips  *Point*pipMultiplier;
   if (UseVoltyTrailingStop)
          StopLoss   = Volty.initialStopLoss*Point*pipMultiplier;
      
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0;c < NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss > 0)   sl = Bid+StopLoss;
            if (TakeProfit > 0) tp = Bid-TakeProfit;
         }
         int ticket = OrderSend(s_symbol,OP_SELL,Lots,Bid,AllowedSlippage*Point*pipMultiplier,sl,tp,"IchiNrtr-sell",MagicNumber,0,Red);
         
         //
         //
         //
         //
         //
         
         int     err = GetLastError(); checkError("sell order opened",err);
  			switch (err)
         {
            case ERR_NO_ERROR:
                 if (EcnBroker && StopLoss>0)   setStopLoss(ticket,Bid+StopLoss);
                 if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Bid-TakeProfit);
                     c=NumberOfTries;
                 continue;
			                 
			   case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
                 Sleep(PAUSE_BEFORE_RETRY);
                 continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
	              continue;

            default:
                 c = NumberOfTries;
                 continue;
         }
   }
}

//----------------------------------------------------------------------------------------
//       orders closing and closing all (take profit mode)
//----------------------------------------------------------------------------------------
//
//
//
//
//

void CloseAll()
{
   for (int i=OrdersTotal()-1; i>=0; i--)
   { 
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber()!=MagicNumber) continue;
      if (!AllSymbolsForProfitAndLoss)
      if (OrderSymbol() != s_symbol)       continue;

      //
      //
      //
      //
      //

      if (OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
         for(int c=0 ; c<3; c++)
         {
            OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,CLR_NONE);
            int     err=GetLastError(); checkError(s_symbol+" order closed",err);
     			switch (err)
            {
   			   case ERR_SERVER_BUSY:
               case ERR_NO_CONNECTION:
               case ERR_INVALID_PRICE:
               case ERR_OFF_QUOTES:
               case ERR_BROKER_BUSY:
               case ERR_TRADE_CONTEXT_BUSY:
                    Sleep(PAUSE_BEFORE_RETRY);
                    continue;

               case ERR_PRICE_CHANGED:
               case ERR_REQUOTE:
	                continue;

               default:
                    c=NumberOfTries;
                    continue;
            }                 
         }
      }
   }
}

//
//
//
//
//

void CloseOrder(double lotsToClose=0,int ticket=-1)
{
   double minLot = NormalizeDouble(MarketInfo(s_symbol,MODE_MINLOT),2);
   string message;

   //
   //
   //
   //
   //
      
   if (IsTesting() || CheckTradeAllowed())
   for(int i=OrdersTotal()-1; i>=0; i--)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber()!=MagicNumber) continue;
      if (OrderSymbol() != s_symbol)       continue;
      if (ticket!=-1)
         if (OrderTicket()!=ticket) continue;
         
      //
      //
      //
      //
      //
         
      if (OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
         if (OrderType()==OP_BUY)
               { string operation = "buy"; color theColor  = Blue;}  
         else  {        operation = "sell";      theColor  = Red; }
            
         //
         //
         //
         //
         //

         if (lotsToClose==0) lotsToClose = OrderLots();
         if (lotsToClose!=OrderLots())
         {
            lotsToClose = MathMax(minLot,lotsToClose);
               if (OrderLots() < 2.0*minLot)
                  lotsToClose = OrderLots();
         }               
            
         if (lotsToClose!=OrderLots())
                  message="partialy closed "+operation+" - closed "+DoubleToStr(lotsToClose,2)+" lots";
         else     message=operation+" order closed";
            
         //
         //
         //
         //
         //
            
         for(int c=0 ; c < NumberOfTries; c++)
         {
            RefreshRates();
            if (OrderType()==OP_BUY)
                  double cp = Bid;  
            else         cp = Ask;
               
            //
            //
            //
            //
            //
               
            OrderClose(OrderTicket(),lotsToClose,cp,AllowedSlippage*Point*pipMultiplier,theColor);
            int err=GetLastError();  checkError(message,err);
     			switch (err)
            {
    			   case ERR_SERVER_BUSY:
               case ERR_NO_CONNECTION:
               case ERR_INVALID_PRICE:
               case ERR_OFF_QUOTES:
               case ERR_BROKER_BUSY:
               case ERR_TRADE_CONTEXT_BUSY:
                    Sleep(PAUSE_BEFORE_RETRY);
                    continue;

               case ERR_PRICE_CHANGED:
               case ERR_REQUOTE:
    	              continue;

               default:
                    c=NumberOfTries;
                    continue;
            }
         }
      }            
   }  
}

//----------------------------------------------------------------------------------------
//       miscellaneus functions           
//----------------------------------------------------------------------------------------
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}

//
//
//
//
//

double volbuyValue(string symbol)
{
   double volbuy = iCustom(symbol,vol.timeFrame,"Volty Channel Stop on jurik-for Ea",0,Price,Length,Phase,Double,AtrLength,Kv,MoneyRisk,0,0,vol.barToUse);
   return(volbuy);
}

double volsellValue(string symbol)
{
   double volsell = iCustom(symbol,vol.timeFrame,"Volty Channel Stop on jurik-for Ea",0,Price,Length,Phase,Double,AtrLength,Kv,MoneyRisk,0,1,vol.barToUse);
   return(volsell);
}

//----------------------------------------------------------------------------------------
//       terminal status handling
//----------------------------------------------------------------------------------------
//
//
//
//
//

bool CheckTradeAllowed() { return(IsTradeAllowed() && !IsStopped() && IsExpertEnabled() && !IsTradeContextBusy()); }
bool CheckTerminalStatus()
{
   bool status=false;
   
   //
   //
   //
   //
   //
   
   while(true)
   {
         if (!IsConnected())
             { showTwoStateMessage("connected","No connection to server",False); break; }
         else  showTwoStateMessage("connected","Reconected to server",true);
         if ( IsStopped())
             { showTwoStateMessage("stopped","EA stopped",False); break; }  
         else  showTwoStateMessage("stopped","EA started again",true);
         if (!IsTradeAllowed())
             { showTwoStateMessage("allowed","Trading not allowed",false); break; }
         else  showTwoStateMessage("allowed","Trading allowed again",true);
         if (!IsExpertEnabled() && !IsTesting())
            { showTwoStateMessage("disabled","EA''s are disabled",false); break; }
         else showTwoStateMessage("disabled","EA''s are enabled again",true);
         if ( IsTradeContextBusy())
            { showTwoStateMessage("busy","Trade contest busy",false); break; }
         else showTwoStateMessage("busy","Trade contest ready again",true);

      //
      //
      //
      //
      //
      
      status=true;
      break;
   }
   if (SpreadProtection)
   {
      if (DontContinue==1)
            showTwoStateMessage("spreads","Spreads widen",false);
      else  showTwoStateMessage("spreads","Spreads normal again",true);
   }            
   return(status);
}

//----------------------------------------------------------------------------------------
//       inter EA messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool FindMessage()
{
   bool found=false;
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if (OrderMagicNumber() == IEAMessagesIDMagic)
      if (OrderComment()     == IEAMessagesID)
      {
        found=true; break;
      }
   }
   return(found);
}

//
//
//
//
//

void PostMessage()
{
   string   message    = IEAMessagesID;
   int      timeToAdd  = 660;
   double   lot        = MarketInfo(s_symbol,MODE_MINLOT);
   datetime expiration = Time[0]+24*3600;
            expiration = StrToTime(TimeToStr(expiration,TIME_DATE)+" 00:00");
   
   //
   //
   //
   //
   //
   
   if (!FindMessage())
   {
     for(int c=0; c<NumberOfTries; c++)
      {
         expiration = MathMax(expiration,TimeCurrent()+timeToAdd);
         
         //
         //
         //
         //
         //
         
         OrderSend(s_symbol,OP_BUYLIMIT,lot,Point,0,0,0,message,IEAMessagesIDMagic,expiration,CLR_NONE);
         int err = GetLastError();
      	switch (err)
 	      {
 	         case ERR_TRADE_EXPIRATION_DENIED:
 	               if (expiration !=0)
 	               {
 	                  message    = IEAMessagesID+IEAMessagesIDExSep+expiration;
                     expiration = 0; 	                   
 	               }
 	               continue;
 	         
            case ERR_INVALID_TRADE_PARAMETERS:
                  timeToAdd += 300;
                  continue;

            case ERR_SERVER_BUSY:
		      case ERR_NO_CONNECTION:
		      case ERR_INVALID_PRICE:
		      case ERR_OFF_QUOTES:
		      case ERR_BROKER_BUSY:
		      case ERR_TRADE_CONTEXT_BUSY:
			          Sleep(PAUSE_BEFORE_RETRY);
			          continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
		              continue;

            default:
	                 c=NumberOfTries;
	                 continue;
         }
      }
   }             
}

//----------------------------------------------------------------------------------------
//       messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool   msg.errState[];
string msg.errNames[];
string msg.messageText[10];
color  msg.messageColor[10];
int    msg.lastMessage=0;

//
//
//
//
//

void checkError(string what,int err)
{
   showMessage(what);
   if(err!=0)
         showMessage("error occured :"+ErrorDescription(err),Red);

}

//
//
//
//
//

void showTwoStateMessage(string name, string message, bool state)
{
   for(int i=ArraySize(msg.errNames)-1; i>=0; i--) if (msg.errNames[i]==name) break;
   if (i==-1)
      {
         int size = ArraySize(msg.errNames)+1;
         i = size-1;
            ArrayResize(msg.errNames,size); msg.errNames[i] = name;
            ArrayResize(msg.errState,size); msg.errState[i] = true;
      }

   //
   //
   //
   //
   //

   if (msg.errState[i]!= state)
   {   
      msg.errState[i] = state;
      if (state==false)
            showMessage(message,Red);
      else  showMessage(message,Green);
   }      
}

//
//
//
//
//

void showMessage(string text, color theColor=Gray)
{
   if(!showMessages) { Print(text); return; }
   
   //
   //
   //
   //
   //
   
   if(msg.lastMessage>9)
   {
      for(int i=0; i<9; i++)
      {
         msg.messageText[i] =msg.messageText[i+1];
         msg.messageColor[i]=msg.messageColor[i+1];
      }
      msg.lastMessage = 9;
   }

   //
   //
   //    set message que text and color
   //
   //
   
      msg.messageText[msg.lastMessage]  = text+" - "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
      msg.messageColor[msg.lastMessage] = theColor;
   
   //
   //
   //
   //
   //
      
   for(i=0; i<=msg.lastMessage; i++)
   {
      string name = "msg.que"+i;
      if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_LABEL,0,0,0);
            ObjectSet(name,OBJPROP_CORNER,3);
            ObjectSet(name,OBJPROP_XDISTANCE,5);
            ObjectSet(name,OBJPROP_YDISTANCE,5+14*i);
      }
      ObjectSetText(name,msg.messageText[i],9,"Arial",msg.messageColor[i]);
   }
   msg.lastMessage++;
   WindowRedraw();
}

//
//
//
//
//

//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol, "CADJPY") >= 0) return(1933921);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(1933922);
   
   if (StringFind(s_symbol, "GOLD"  ) >= 0) return(1933931);
   if (StringFind(s_symbol, "SILVER") >= 0) return(1933932);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(1933941);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(1933942);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(1933951);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(1933961);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(1933962);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(1933963);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(1933964);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(1933965);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(1933966);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(1933967);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(1933971);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(1933972);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(1933973);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(1933981);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(1933982);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(1933983);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(1933991);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(1933992);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(1933993);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(1933994);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(1933995);
   
return(ManualMagic);
}


